%bcond_without check
%global crate rav1e

Summary:        Fastest and safest AV1 encoder
Name:           rust-rav1e
Version:        0.6.4
Release:        3%{?dist}
License:        BSD-2-Clause AND ISC
Source0:        https://github.com/xiph/rav1e/archive/refs/tags/v%{version}.tar.gz #/%{crate}-%{version}.tar.gz
# cd source directory; cargo vendor; tar
Source1:        vendor.tar.gz
 
BuildRequires:  cargo-c nasm rust-toolset

%description
rav1e is an AV1 video encoder. It is designed to eventually cover all use cases,
though in its current form it is most suitable for cases where libaom
(the reference encoder) is too slow.

Features:
1. Intra, inter, and switch frames
2. 64x64 superblocks
3. 4x4 to 64x64 RDO-selected square and rectangular blocks
4. DC, H, V, Paeth, smooth, and all directional prediction modes
5. DCT, (FLIP-)ADST and identity transforms (up to 64x64, 16x16 and 32x32 respectively)
6. 8-, 10- and 12-bit depth color
7. 4:2:0, 4:2:2 and 4:4:4 chroma sampling
8. 11 speed settings (0-10, exhaustive to near real-time)
9. Constant quantizer and target bitrate (single- and multi-pass) encoding modes
10.Still picture mode


%package     -n %{crate}
Summary:        Fastest and safest AV1 encoder
License:        BSD-2-Clause AND ISC AND MIT

%description -n %{crate}
rav1e is an AV1 video encoder.


%package     -n %{crate}-libs
Summary:        Library files for %{crate}
License:        BSD-2-Clause AND ISC AND MIT

%description -n %{crate}-libs
Library files for %{crate}, the fastest and safest AV1 encoder.


%package     -n %{crate}-devel
Summary:        Development files for %{crate}
License:        BSD-2-Clause AND ISC AND MIT
Requires:       %{crate}-libs = %{version}-%{release}

%description -n %{crate}-devel
The package contains libraries and header files for developing applications
that use rav1e.


%prep
%autosetup -n %{crate}-%{version}
%cargo_prep -V 1
# Disable rav1e_js
sed -i 's/"rav1e_js", //' Cargo.toml


%build
%cargo_build
CFLAGS="%{optflags}" cargo cbuild


%install
%cargo_install
rm -rf %{buildroot}%{_datadir}/cargo

cargo cinstall \
    --destdir=%{buildroot} \
    --prefix=%{_prefix} \
    --libdir=%{_libdir} \
    --includedir=%{_includedir} \
    --pkgconfigdir=%{_libdir}/pkgconfig
rm -f %{buildroot}%{_libdir}/librav1e.a
rm -f %{buildroot}%{_prefix}/.crates*


%if %{with check}
%check
%cargo_test
%endif


%files -n %{crate}
%license LICENSE PATENTS
%doc README.md
%{_bindir}/rav1e


%files -n %{crate}-libs
%license LICENSE PATENTS
%doc README.md
%{_libdir}/librav1e.so.0*


%files -n %{crate}-devel
%{_includedir}/rav1e/
%{_libdir}/librav1e.so
%{_libdir}/pkgconfig/rav1e.pc


%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.6.4-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.6.4-2
- Rebuilt for OpenCloudOS Stream 23.05

* Sun Apr 23 2023 rockerzhu <rockerzhu@tencent.com> - 0.6.4-1
- Initial build.
